eo::base Struct Reference

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files
- Examples

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions | Static Public Member Functions
eo::base Struct Reference

Class base. More...

## Public Member Functions
| base (Eo *eo)
| Eo Constructor. More...
| base (std::nullptr_t)
| nullptr_t Constructor. More...
| base (base const &other)
| Copy Constructor.
void | event_callback_forwarder_del (const Eo_Event_Description *desc_,::efl::eo::concrete new_obj_) const
| Remove an event callback forwarder for an event and an object. More...
void | event_thaw () const
| thaw events of object. More...
void | event_freeze () const
| freeze events of object. More...
void | event_callback_array_del (const Eo_Callback_Array_Item *array_, const void *user_data_) const
| Del a callback array with a specific data associated to it for an event. More...
void | wref_del (Eo **wref_) const
| Delete the weak reference passed. More...
void | destructor () const
| Call the object's destructor. More...
::efl::eo::concrete | finalize () const
| Called at the end of #eo_add. More...
void | key_data_set (::efl::eina::string_view key_, const void *data_, eo_key_data_free_func free_func_) const
| Set generic data to object. More...
void * | key_data_get (::efl::eina::string_view key_) const
| Get generic data from object. More...
void | event_callback_del (const Eo_Event_Description *desc_, Eo_Event_Cb func_, const void *user_data_) const
| Del a callback with a specific data associated to it for an event. More...
void | key_data_del (::efl::eina::string_view key_) const
| Del generic data from object. More...
void | event_callback_array_priority_add (const Eo_Callback_Array_Item *array_, Eo_Callback_Priority priority_, const void *data_) const
| Add a callback array for an event with a specific priority. More...
void | wref_add (::efl::eo::concrete *wref_) const
| Add a new weak reference to obj. More...
void | dbg_info_get (Eo_Dbg_Info *root_node_) const
| Get dbg information from the object. More...
void | event_callback_forwarder_add (const Eo_Event_Description *desc_,::efl::eo::concrete new_obj_) const
| Add an event callback forwarder for an event and an object. More...
bool | event_callback_call (const Eo_Event_Description *desc_, void *event_info_) const
| Call the callbacks for an event of an object. More...
void | event_callback_priority_add (const Eo_Event_Description *desc_, Eo_Callback_Priority priority_, Eo_Event_Cb cb_, const void *data_) const
| Add a callback for an event with a specific priority. More...
Eina_Iterator * | children_iterator_new () const
| Get an iterator on all childrens.
bool | composite_attach (::efl::eo::concrete comp_obj_) const
bool | composite_detach (::efl::eo::concrete comp_obj_) const
bool | composite_part_is () const
::efl::eo::concrete | parent_get () const
| Get the parent of an object. More...
void | parent_set (::efl::eo::concrete parent_) const
| Set the parent of an object Parents keep references to their children so in order to delete objects that have parents you need to set parent to NULL or use eo_del() that does that for you (and also unrefs the object). More...
int | event_global_freeze_count_get () const
| return freeze events of object. More...
int | event_freeze_count_get () const
| return freeze events of object. More...
bool | finalized_get () const
template<typename F >
::efl::eo::signal_connection | callback_callback_add_add (F &&callback_,::efl::eo::callback_priority priority_=::efl::eo::callback_priorities::default_)
| A callback was added.
template<typename T >
void | callback_callback_add_call (T *info)
| A callback was added.
template<typename F >
::efl::eo::signal_connection | callback_callback_del_add (F &&callback_,::efl::eo::callback_priority priority_=::efl::eo::callback_priorities::default_)
| A callback was deleted.
template<typename T >
void | callback_callback_del_call (T *info)
| A callback was deleted.
template<typename F >
::efl::eo::signal_connection | callback_del_add (F &&callback_,::efl::eo::callback_priority priority_=::efl::eo::callback_priorities::default_)
| Obj is being deleted.
template<typename T >
void | callback_del_call (T *info)
| Obj is being deleted.
| base (::efl::eo::parent_type _p)
| Constructs a new eo::base object. More...
Public Member Functions inherited from efl::eo::concrete
| concrete (Eo *eo)
| Class constructor. More...
| concrete ()
| Default constructor. More...
| ~concrete ()
| Class destructor.
| concrete (concrete const &other)
| concrete (concrete &&other)
concrete & | operator= (concrete const &other)
| Assignment operator.
concrete & | operator= (concrete &&other)
Eo * | _eo_ptr () const
| Return a pointer to the EO Object stored in this instance. More...
Eo * | _release ()
| Releases the reference from this concrete object and return the pointer to the EO Object stored in this instance. More...
void | _reset (Eo *_ptr=nullptr)
| Reset the current pointer to reference a new Eo object.
int | ref_get () const
| Get the reference count of this object. More...
void | parent_set (concrete parent)
| Set the parent of this object. More...
eina::optional< concrete > | parent_get ()
| Get the parent of this object. More...
Eo_Dbg_Info | dbg_info_get ()
| Get debug information of this object. More...
| operator bool () const

## Static Public Member Functions
static void | event_global_freeze ()
| freeze events of object. More...
static void | event_global_thaw ()
| thaw events of object. More...
static Eo_Class const * | _eo_class ()

## Additional Inherited Members
Protected Attributes inherited from efl::eo::concrete
Eo * | _eo_raw
| The opaque EO Object.

## Detailed Description

Class base.

## Constructor & Destructor Documentation

eo::base::base | ( | ::efl::eo::parent_type | _p | ) |
| inlineexplicit

Constructs a new eo::base object.

Constructs a new eo::base object. If you want this object to be a child of another Eo object, use an efl::eo::parent expression, like the example.

Example:

eo::base my_base(efl::eo::parent = parent_object);

See also
  base(Eo* eo)

eo::base::base | ( | Eo * | eo | ) |
| inlineexplicit

Eo Constructor.

Constructs the object from an Eo* pointer stealing its ownership.

Parameters

  eo | The Eo object pointer.

eo::base::base | ( | std::nullptr_t |  | ) |
| inlineexplicit

nullptr_t Constructor.

Constructs an empty (null) object.

## Member Function Documentation

void eo::base::event_callback_forwarder_del | ( | const Eo_Event_Description * | desc_,
|  | ::efl::eo::concrete | new_obj_
| ) |  | const

Remove an event callback forwarder for an event and an object.

Parameters

  desc | The description of the event to listen to
  new_obj | The object to emit events from

void eo::base::event_thaw | ( |  | ) | const

thaw events of object.

Lets event callbacks be called for the object.

void eo::base::event_freeze | ( |  | ) | const

freeze events of object.

Prevents event callbacks from being called for the object.

static void eo::base::event_global_freeze | ( |  | ) |
| static

freeze events of object.

Prevents event callbacks from being called for the object.

void eo::base::event_callback_array_del | ( | const Eo_Callback_Array_Item * | array_,
|  | const void * | user_data_
| ) |  | const

Del a callback array with a specific data associated to it for an event.

Parameters

  array | an #Eo_Callback_Array_Item of events to listen to
  user_data | The data to compare

void eo::base::wref_del | ( | Eo ** | wref_ | ) | const

Delete the weak reference passed.

Parameters

  wref |

void eo::base::destructor | ( |  | ) | const

Call the object's destructor.

Should not be used with #eo_do. Only use it with #eo_do_super.

::efl::eo::concrete eo::base::finalize | ( |  | ) | const

Called at the end of #eo_add.

Should not be called, just overridden.

Returns
  The new object created, can be NULL if the finalize func decided to abort (though it should free the created object on it's own).

void eo::base::key_data_set | ( | ::efl::eina::string_view | key_,
|  | const void * | data_,
|  | eo_key_data_free_func | free_func_
| ) |  | const

Set generic data to object.

Parameters

  key | the key associated with the data
  data | the data to set
  free_func | the func to free data with (NULL means

void* eo::base::key_data_get | ( | ::efl::eina::string_view | key_ | ) | const

Get generic data from object.

Parameters

  key | the key associated with the data

void eo::base::event_callback_del | ( | const Eo_Event_Description * | desc_,
|  | Eo_Event_Cb | func_,
|  | const void * | user_data_
| ) |  | const

Del a callback with a specific data associated to it for an event.

Parameters

  desc | The description of the event to listen to
  func | the callback to delete
  user_data | The data to compare

static void eo::base::event_global_thaw | ( |  | ) |
| static

thaw events of object.

Lets event callbacks be called for the object.

void eo::base::key_data_del | ( | ::efl::eina::string_view | key_ | ) | const

Del generic data from object.

Parameters

  key | the key associated with the data

void eo::base::event_callback_array_priority_add | ( | const Eo_Callback_Array_Item * | array_,
|  | Eo_Callback_Priority | priority_,
|  | const void * | data_
| ) |  | const

Add a callback array for an event with a specific priority.

callbacks of the same priority are called in reverse order of creation.

Parameters

  array | an #Eo_Callback_Array_Item of events to listen to
  priority | The priority of the callback
  data | additional data to pass to the callback

void eo::base::wref_add | ( | ::efl::eo::concrete * | wref_ | ) | const

Add a new weak reference to obj.

This function registers the object handle pointed by wref to obj so when obj is deleted it'll be updated to NULL. This functions should be used when you want to keep track of an object in a safe way, but you don't want to prevent it from being freed.

Parameters

  [out] | wref |

void eo::base::dbg_info_get | ( | Eo_Dbg_Info * | root_node_ | ) | const

Get dbg information from the object.

Parameters

  root_node | node of the tree

void eo::base::event_callback_forwarder_add | ( | const Eo_Event_Description * | desc_,
|  | ::efl::eo::concrete | new_obj_
| ) |  | const

Add an event callback forwarder for an event and an object.

Parameters

  desc | The description of the event to listen to
  new_obj | The object to emit events from

bool eo::base::event_callback_call | ( | const Eo_Event_Description * | desc_,
|  | void * | event_info_
| ) |  | const

Call the callbacks for an event of an object.

Parameters

  desc | The description of the event to call
  event_info | Extra event info to pass to the callbacks

void eo::base::event_callback_priority_add | ( | const Eo_Event_Description * | desc_,
|  | Eo_Callback_Priority | priority_,
|  | Eo_Event_Cb | cb_,
|  | const void * | data_
| ) |  | const

Add a callback for an event with a specific priority.

callbacks of the same priority are called in reverse order of creation.

Parameters

  desc | The description of the event to listen to
  priority | The priority of the callback
  cb | the callback to call
  data | additional data to pass to the callback

bool eo::base::composite_attach | ( | ::efl::eo::concrete | comp_obj_ | ) | const

Parameters

  comp_obj | the object that will be used to composite the parent.

Returns
  EINA_TRUE if successfull. EINA_FALSE otherwise.

bool eo::base::composite_detach | ( | ::efl::eo::concrete | comp_obj_ | ) | const

Parameters

  comp_obj | the object that will be removed from the parent.

Returns
  EINA_TRUE if successfull. EINA_FALSE otherwise.

bool eo::base::composite_part_is | ( |  | ) | const

Returns
  EINA_TRUE if it is. EINA_FALSE otherwise.

::efl::eo::concrete eo::base::parent_get | ( |  | ) | const

Get the parent of an object.

Parameters

  parent | the new parent

void eo::base::parent_set | ( | ::efl::eo::concrete | parent_ | ) | const

Set the parent of an object Parents keep references to their children so in order to delete objects that have parents you need to set parent to NULL or use eo_del() that does that for you (and also unrefs the object).

Parameters

  parent | the new parent

int eo::base::event_global_freeze_count_get | ( |  | ) | const

return freeze events of object.

Return event freeze count.

Parameters

  fcount | The event freeze count of the object

int eo::base::event_freeze_count_get | ( |  | ) | const

return freeze events of object.

Return event freeze count.

Parameters

  fcount | The event freeze count of the object

bool eo::base::finalized_get | ( |  | ) | const

Parameters

  finalized |